/*****************************************************************************/
/**                                                                         **/
/**                          h y s t . h                                    **/
/**                                                                         **/
/*****************************************************************************/
/**                                                                         **/
/**                  Copyrights(c) 2008 by Andras Huszti,                   **/
/**                              Budapest                                   **/
/**                                                                         **/
/** Project   :    PID library                                              **/
/** Date      :    22.08.2008                                               **/
/** Author    :    A. Huszti                                                **/
/**                                                                         **/
/*****************************************************************************/
/** Content: Short description / summary                                    **/
/**                                                                         **/
/*****************************************************************************/
/** Date       Author        Rev  Changes:                                  **/
/** 22.08.2008 A. Huszti     1.0  Start:                                    **/
/**                                                                         **/
/*****************************************************************************/

#ifndef _HYST_H_
#define _HYST_H_

/******************* Header / include files ( #include ) *********************/

/***************** Constant / macro definitions ( #define ) ******************/

/*********************** Type definitions ( typedef ) ************************/

typedef struct  {
	double temp;
	double hyst_min;
	double hyst_max;
	double to_min;
	double to_max;
	double input;
} Hyst;

/******************* Global data declarations ( extern ) *********************/

/******* External parameter / constant declarations ( extern const ) *********/

/************************ Global func/proc prototypes ************************/

/** Function doControling ****************************************************/
/**                                                                         **/
/** Function :                                                              **/
/** Param In :                                                              **/
/** Param Out:                                                              **/
/** Return   :                                                              **/
/** Data In  :                                                              **/
/** Data Out :                                                              **/
/** Remarks  :                                                              **/
/*****************************************************************************/
extern double doHyst(Hyst *hyst);

#endif
/** EndOfFile hyst.h *********************************************************/
